/***
*
* XBNBT Beta 81b.3.4 - A C++ BitTorrent Tracker
* Copyright (C) 2003-2004 =Xotic=
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
***/

#if defined XBNBT_MYSQL || defined BNBT_MYSQL

#include "bnbt.h"
#include "xmysqlusers.h"
#include "atom.h"
#include "config.h"
#include "tracker.h"
#include "util.h"

// XBNBT Language support
#include "xconfig_lang.h"   

// Initialise XBNBT MySQL Users variables
void CTracker :: initMySQLUsersVars( )
{
	m_strForumLink = CFG_GetString( "xbnbt_mysqlusers_forums_link", string( ) );    
	m_iMySQLUsersLoadInterval = CFG_GetInt( "xbnbt_mysqlusers_interval", 10 );  
	m_strMySQLUsersID = CFG_GetString( "xbnbt_mysqlusers_table_id", string( ) );
	m_strMySQLUsersGroup = CFG_GetString( "xbnbt_mysqlusers_table_group", string( ) );
	m_strMySQLUsersPassword = CFG_GetString( "xbnbt_mysqlusers_table_password", string( ) );
	m_strMySQLUsersEmail = CFG_GetString( "xbnbt_mysqlusers_table_email", string( ) );
	m_strMySQLUsersJoined = CFG_GetString( "xbnbt_mysqlusers_table_joined", string( ) );
	m_strMySQLUsersIgnoreGroup1 = CFG_GetString( "xbnbt_mysqlusers_ignore_group1", string( ) );
	m_strMySQLUsersIgnoreGroup2 = CFG_GetString( "xbnbt_mysqlusers_ignore_group2", string( ) );
	m_strMySQLUsersIgnoreGroup3 = CFG_GetString( "xbnbt_mysqlusers_ignore_group3", string( ) );
}

// XBNBT MySQL Users Integration
void CTracker :: loadMySQLUsers( )
{
	time_t tmp;
	char pTime[256];
	memset( pTime, 0, sizeof( char ) * 256 );

	CAtomDicti *m_pMySQLUsersUsers = new CAtomDicti( );

	string strQuery = "SELECT " + m_strMySQLUsersID + "," + gstrMySQLUsersName + "," + m_strMySQLUsersGroup + "," + m_strMySQLUsersPassword + ",xbnbt_perm," + m_strMySQLUsersEmail + "," + m_strMySQLUsersJoined + " FROM " + gstrMySQLUsersTable;
	//string strQuery = "SELECT id,name,mgroup,password,xbnbt_perm,email,joined FROM " + gstrMySQLUsersTable;

	CMySQLUsersQuery *pQuery = new CMySQLUsersQuery( strQuery );

	vector<string> vecQuery;

	int iCountUsers = 0;

	while( ( vecQuery = pQuery->nextRow( ) ).size( ) == 7 )
	{
		// Do not process if user group is guest(2), validating(1) or banned(5)
		//if( !( vecQuery[2] == "1" ) && !( vecQuery[2] == "2" ) && !( vecQuery[2] == "5" ) )
		if( !( vecQuery[2] == m_strMySQLUsersIgnoreGroup1 ) && !( vecQuery[2] == m_strMySQLUsersIgnoreGroup2 ) && !( vecQuery[2] == m_strMySQLUsersIgnoreGroup3 ) )
		{
			iCountUsers++;

			tmp = atoi( vecQuery[6].c_str( ) );

			strftime( pTime, sizeof( char ) * 256, "%Y-%m-%d %H:%M:%S", localtime( &tmp ) );

			CAtomDicti *pUser = new CAtomDicti( );

			pUser->setItem( "md5", new CAtomString( vecQuery[3] ) );
			pUser->setItem( "access", new CAtomLong( UTIL_StringTo64( vecQuery[4].c_str( ) ) ) );
			pUser->setItem( "email", new CAtomString( vecQuery[5] ) );
			pUser->setItem( "created", new CAtomString( pTime ) );

			m_pMySQLUsersUsers->setItem( vecQuery[1], pUser );
		}
	}

	delete pQuery;

	if( iCountUsers && m_pMySQLUsersUsers && m_pMySQLUsersUsers->isDicti( ) )
	{
		delete m_pUsers;

		//CAtomDicti *m_pUser = new CAtomDicti( );

		m_pUsers = (CAtomDicti *)m_pMySQLUsersUsers;
		m_strMySQLUsersLoadLast = UTIL_Date( );

		if( m_bBoot )
		{
			m_strMySQLUsersLoadLastStatus = gmapLANG_CFG["at_run_time"] ;
			m_bBoot = false;
		}
		else
			m_strMySQLUsersLoadLastStatus = gmapLANG_CFG["loaded"] ;

		UTIL_LogPrint( string( gmapLANG_CFG["loaded_mysql_users"] + "\n" ).c_str( ), iCountUsers );
	}
	else
	{
		m_strMySQLUsersLoadLastStatus = gmapLANG_CFG["failed"] + ": " + UTIL_Date( );

		UTIL_LogPrint( string( gmapLANG_CFG["not_loaded_mysql_users"] + "\n" ).c_str( ) );

		if( m_pMySQLUsersUsers )
			delete m_pMySQLUsersUsers;
	}
}

void CTracker :: runLoadMySQLUsers( )
{
	if( giMySQLUsersOverrideUsers )
	{
		if( gbDebug )
			UTIL_LogPrint( string( gmapLANG_CFG["loading_mysql_users"] + "\n" ).c_str( ) );

		loadMySQLUsers( );
		m_strMySQLUsersLoadNext = GetTime( ) + m_iMySQLUsersLoadInterval * 60;
	}
}

#endif
